class Edge
{
  Node from; 
  Node to; 
  float len; 
  PVector v;
  int count; 
  
  void increment()
  {
    count++; 
  }
  
  
  Edge(Node from, Node to)
  {
    this.from = from; 
    this.to = to; 
    this.len = cLength-count;
    //len = constrain(len,50,100);  
  }
  
  void relax()
  {
    len = cLength-count;
    v = new PVector(0,0,0); 
    v.set(to.loc.x - from.loc.x, to.loc.y - from.loc.y, to.loc.z - from.loc.z);
    float dis = v.mag();  
    if(dis > 0)
    {
      float f = (len - dis) / (dis*3); 
      
      float dx = f * v.x; 
      float dy = f * v.y; 
      float dz = f * v.z;
      
      to.d.x += dx; 
      to.d.y += dy; 
      to.d.z += dz; 
       
      from.d.x -= dx; 
      from.d.y -= dy; 
      from.d.z -= dz; 
      
    }
  }
  
  void draw()
  {
    stroke(edgeColor,100-from.count*10); 
    //stroke(edgeColor,50); 
    //stroke(0,50); 
    strokeWeight(to.count); 
    line(from.loc.x, from.loc.y, from.loc.z, to.loc.x, to.loc.y, to.loc.z); 
  }  
};      

