class Node
{
  PVector loc; 
  PVector d; 
  PVector v; 
  PVector dd;
  boolean fixed; 
  String label;
  color c; 
  int id; 
  int count; 


  void increment()
  {
    count++;
  }


  Node(String label)
  {
    this.label = label; 
    loc = new PVector(random(-100, 100), random(-100, 100), random(-100, 100));
    d = new PVector(0, 0, 0);
    v = new PVector(0, 0, 0);
    dd = new PVector(0, 0, 0);
    fixed = false; 
    c = color(random(255), 250, 50); 
    id = nodeCount;
  }

  public void changeColor() {
    int r = (int)red(c);
    int g = (int)green(c);
    int b = (int)blue(c);
    c = color(r, 255 - g, b);
  }

  void relax()
  {
    dd.set(0, 0, 0); 

    for (int j = 0; j < nodeCount; j++)
    {
      Node n = nodes[j]; 

      if (n != this)
      {
        v.set(loc.x - n.loc.x, loc.y - n.loc.y, loc.z - n.loc.z); 

        float lensq = v.mag();
        lensq *= lensq; 

        if (lensq == 0) 
        {
          dd.add(random(-10, 10), random(-10, 10), random(-10, 10));
        } 
        else if (lensq < 100*100)
        {
          v.normalize();
          dd.add(v);
        }
      }
    }


    float dlen = d.mag()/2.0;

    if (dlen > 0) 
    {
      dd.normalize();
      d.add(dd);
    }
  }

  public void focus() 
  {
    cam.lookAt(loc.x, loc.y, loc.z, 200, 1000); //lookat xyz - speed 1000 ms
  }


  void update()
  {
    if (!fixed)
    {
      loc.x+= constrain(d.x, -5, 5);
      loc.y+= constrain(d.y, -5, 5);
      loc.z+= constrain(d.z, -5, 5);

      loc.x = constrain(loc.x, -1000, 1000); 
      loc.y = constrain(loc.y, -1000, 1000); 
      loc.z = constrain(loc.z, -1000, 1000);
    }

    d.x*= .790; 
    d.y*= .790; 
    d.z*= .790;
  }

  void draw(PGraphics g)
  {
    g.pushMatrix();
    g.translate(loc.x, loc.y, loc.z);
  
    if (selection == this)
    {
      g.fill(selectColor, 50);
      g.stroke(selectColor, 50);
    } 
    else if (fixed)
    {
      g.fill(fixedColor, 50); 
      g.stroke(fixedColor, 50);
    } 
    else 
    {
      g.fill(nodeColor, 50); 
      g.stroke(fixedColor, 50);
    }
    g.stroke(200, 100); 
    g.box(3+count*2); 

    if (selection == this)
    {
      g.fill(selectColor, count*80);
    } 
    else if (fixed)
    {
      g.fill(fixedColor, count*80);
    } 
    else 
    {
      g.fill(fontColor, count*80);
    }

    // keep labels facing camera
    g.rotateX(rotations[0]); 
    g.rotateY(rotations[1]); 
    g.rotateZ(rotations[2]);
    
    g.textFont(font); 
    g.textSize(constrain(count+5, 5, 20));
    g.textAlign(LEFT, CENTER);  
    g.text(label, 3+count, 0); 
    g.popMatrix();
  }

  void drawBuffer(PGraphics buffer) 
  {
    color idColor = getColor(id);
    buffer.fill(idColor);
    buffer.noStroke(); 
    buffer.pushMatrix(); 
    buffer.translate(loc.x, loc.y, loc.z);
    buffer.box(3+count*2); 
    buffer.popMatrix();
  }
};





